/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_dtc.c
* Version      : CodeGenerator for RL78/G14 V2.05.04.02 [20 Nov 2019]
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file implements device driver for DTC module.
* Creation Date: 
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_dtc.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_cg_adc.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#pragma address dtc_vectortable = 0x0FFB00U
uint8_t __near dtc_vectortable[40U];

#pragma address dtc_controldata_0 = 0x0FFB40U
st_dtc_data __near dtc_controldata_0;

#pragma address dtc_controldata_1 = 0x0FFB48U
st_dtc_data __near dtc_controldata_1;

#pragma address dtc_controldata_2 = 0x0FFB50U
st_dtc_data __near dtc_controldata_2;

#pragma address dtc_controldata_3 = 0x0FFB58U
st_dtc_data __near dtc_controldata_3;

#pragma address dtc_controldata_4 = 0x0FFB60U
st_dtc_data __near dtc_controldata_4;

#pragma address dtc_controldata_5 = 0x0FFB68U
st_dtc_data __near dtc_controldata_5;


/***********************************************************************************************************************
* Function Name: R_DTC_Create
* Description  : This function initializes the DTC module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_DTC_Create(void)
{
    /* Enable input clock supply */
    DTCEN = 1U;
    /* Disable all DTC channels operation */
    DTCEN0 = 0x00U;
    DTCEN1 = 0x00U;
    DTCEN2 = 0x00U;
    DTCEN3 = 0x00U;
    DTCEN4 = 0x00U;
    /* Set base address */
    DTCBAR = 0xFBU;
    /* Set DTCD0 */
    dtc_vectortable[10] = 0x40U;
    dtc_controldata_0.dtccr = _00_DTC_TRANSFER_MODE_NORMAL | _40_DTC_DATA_SIZE_16BITS | _00_DTC_SOURCE_ADDR_FIXED |
                              _08_DTC_DEST_ADDR_INCREMENTED | _10_DTC_CHAIN_TRANSFER_ENABLE;
    dtc_controldata_0.dtbls = _01_DTCD0_TRANSFER_BLOCKSIZE;
    dtc_controldata_0.dtcct = _01_DTCD0_TRANSFER_BYTE;
    dtc_controldata_0.dtrld = _01_DTCD0_TRANSFER_BYTE;
    dtc_controldata_0.dtsar = _FFFF_DTCD0_SRC_ADDRESS;
    dtc_controldata_0.dtdar = _FEFF_DTCD0_DEST_ADDRESS;
    /* Set DTCD1 */
    dtc_controldata_1.dtccr = _00_DTC_TRANSFER_MODE_NORMAL | _00_DTC_DATA_SIZE_8BITS | _04_DTC_SOURCE_ADDR_INCREMENTED |
                              _00_DTC_DEST_ADDR_FIXED | _10_DTC_CHAIN_TRANSFER_ENABLE;
    dtc_controldata_1.dtbls = _01_DTCD1_TRANSFER_BLOCKSIZE;
    dtc_controldata_1.dtcct = _01_DTCD1_TRANSFER_BYTE;
    dtc_controldata_1.dtrld = 0x00U;
    dtc_controldata_1.dtsar = _FEFF_DTCD1_SRC_ADDRESS;
    dtc_controldata_1.dtdar = _FFFF_DTCD1_DEST_ADDRESS;
    /* Set DTCD2 */
    dtc_controldata_2.dtccr = _00_DTC_TRANSFER_MODE_NORMAL | _00_DTC_DATA_SIZE_8BITS | _04_DTC_SOURCE_ADDR_INCREMENTED |
                              _00_DTC_DEST_ADDR_FIXED | _10_DTC_CHAIN_TRANSFER_ENABLE;
    dtc_controldata_2.dtbls = _01_DTCD2_TRANSFER_BLOCKSIZE;
    dtc_controldata_2.dtcct = _01_DTCD2_TRANSFER_BYTE;
    dtc_controldata_2.dtrld = 0x00U;
    dtc_controldata_2.dtsar = _FEFF_DTCD2_SRC_ADDRESS;
    dtc_controldata_2.dtdar = _FFFF_DTCD2_DEST_ADDRESS;
    /* Set DTCD3 */
    dtc_controldata_3.dtccr = _00_DTC_TRANSFER_MODE_NORMAL | _00_DTC_DATA_SIZE_8BITS | _00_DTC_SOURCE_ADDR_FIXED |
                              _00_DTC_DEST_ADDR_FIXED | _10_DTC_CHAIN_TRANSFER_ENABLE;
    dtc_controldata_3.dtbls = _01_DTCD3_TRANSFER_BLOCKSIZE;
    dtc_controldata_3.dtcct = _01_DTCD3_TRANSFER_BYTE;
    dtc_controldata_3.dtrld = 0x00U;
    dtc_controldata_3.dtsar = _FFFF_DTCD3_SRC_ADDRESS;
    dtc_controldata_3.dtdar = _FEFF_DTCD3_DEST_ADDRESS;
    /* Set DTCD4 */
    dtc_controldata_4.dtccr = _00_DTC_TRANSFER_MODE_NORMAL | _00_DTC_DATA_SIZE_8BITS | _00_DTC_SOURCE_ADDR_FIXED |
                              _00_DTC_DEST_ADDR_FIXED | _00_DTC_CHAIN_TRANSFER_DISABLE;
    dtc_controldata_4.dtbls = _01_DTCD4_TRANSFER_BLOCKSIZE;
    dtc_controldata_4.dtcct = _01_DTCD4_TRANSFER_BYTE;
    dtc_controldata_4.dtrld = 0x00U;
    dtc_controldata_4.dtsar = _FFFF_DTCD4_SRC_ADDRESS;
    dtc_controldata_4.dtdar = _FEFF_DTCD4_DEST_ADDRESS;
    /* Set DTCD5 */
    dtc_vectortable[19] = 0x68U;
    dtc_controldata_5.dtccr = _00_DTC_TRANSFER_MODE_NORMAL | _00_DTC_DATA_SIZE_8BITS | _00_DTC_SOURCE_ADDR_FIXED |
                              _00_DTC_DEST_ADDR_FIXED | _00_DTC_CHAIN_TRANSFER_DISABLE;
    dtc_controldata_5.dtbls = _01_DTCD5_TRANSFER_BLOCKSIZE;
    dtc_controldata_5.dtcct = _01_DTCD5_TRANSFER_BYTE;
    dtc_controldata_5.dtrld = 0x00U;
    dtc_controldata_5.dtsar = _FFFF_DTCD5_SRC_ADDRESS;
    dtc_controldata_5.dtdar = _FEFF_DTCD5_DEST_ADDRESS;
}

/***********************************************************************************************************************
* Function Name: R_DTCD0_Start
* Description  : This function enables DTCD0 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_DTCD0_Start(void)
{
    DTCEN1 |= _20_DTC_AD_ACTIVATION_ENABLE;
}

/***********************************************************************************************************************
* Function Name: R_DTCD0_Stop
* Description  : This function disables DTCD0 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_DTCD0_Stop(void)
{
    DTCEN1 &= (uint8_t)~_20_DTC_AD_ACTIVATION_ENABLE;
}

/***********************************************************************************************************************
* Function Name: R_DTCD5_Start
* Description  : This function enables DTCD5 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_DTCD5_Start(void)
{
    DTCEN2 |= _10_DTC_TAU00_ACTIVATION_ENABLE;
}

/***********************************************************************************************************************
* Function Name: R_DTCD5_Stop
* Description  : This function disables DTCD5 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_DTCD5_Stop(void)
{
    DTCEN2 &= (uint8_t)~_10_DTC_TAU00_ACTIVATION_ENABLE;
}

/* Start user code for adding. Do not edit comment generated here */

/******************************************************************************
* Function Name: U_DTCD0_Start
* Description  : This function starts DTCD0 module operation.
* Arguments    : None
* Return Value : None
******************************************************************************/
void U_DTCD0_Start(void)
{
    dtc_controldata_0.dtcct = ADC_CH_LIST_NUM;
    dtc_controldata_0.dtsar = (uint16_t)&ADCR;
    dtc_controldata_0.dtdar = (uint16_t)&g_adc_adcr[0];

    dtc_controldata_1.dtcct = ADC_CH_LIST_NUM;
    dtc_controldata_1.dtsar = (uint16_t)&g_adc_ads[1];
    dtc_controldata_1.dtdar = (uint16_t)&ADS;

    dtc_controldata_2.dtcct = ADC_CH_LIST_NUM;
    dtc_controldata_2.dtsar = (uint16_t)&g_adc_adm0[1];
    dtc_controldata_2.dtdar = (uint16_t)&ADM0;

    dtc_controldata_3.dtcct = ADC_CH_LIST_NUM;
    dtc_controldata_3.dtsar = (uint16_t)&g_adc_p1_high[1];
    dtc_controldata_3.dtdar = (uint16_t)&P1;

    dtc_controldata_4.dtcct = ADC_CH_LIST_NUM;
    dtc_controldata_4.dtsar = (uint16_t)&g_adc_p1_low[1];
    dtc_controldata_4.dtdar = (uint16_t)&P1;

    R_DTCD0_Start();
}

/******************************************************************************
* Function Name: U_DTCD5_Start
* Description  : This function starts DTCD5 module operation.
* Arguments    : None
* Return Value : None
******************************************************************************/
void U_DTCD5_Start(void)
{
    ADS = g_adc_ads[0];

    dtc_controldata_5.dtcct = 1;
    dtc_controldata_5.dtsar = (uint16_t)&g_adc_adm0[0];
    dtc_controldata_5.dtdar = (uint16_t)&ADM0;

    R_DTCD5_Start();
}

/* End user code. Do not edit comment generated here */
